package com.example.iplace.main.viewModel.mainView

import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.size
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.CircleShape
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.ArrowBack
import androidx.compose.material.icons.filled.Delete
import androidx.compose.material3.AlertDialog
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.material3.OutlinedTextField
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.rememberCoroutineScope
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.layout.ContentScale
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.text.TextStyle
import androidx.compose.ui.text.font.Font
import androidx.compose.ui.text.font.FontFamily
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.text.style.TextAlign
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.navigation.NavHostController
import coil.compose.AsyncImage
import com.example.iplace.R
import com.example.iplace.main.viewModel.MainViewModel
import com.example.iplace.model.Users
import com.example.iplace.ui.theme.brown_contrast
import kotlinx.coroutines.launch

@Composable
fun UserSettings(navController: NavHostController) {
    val viewModel = MainViewModel()
    val headlinesOswald = FontFamily( //выбор шрифта
        Font(resId = R.font.headlines_oswald)
    )
    val basicNunitosans = FontFamily(
        Font(resId = R.font.basic_nunitosans)
    )


    var user by remember { mutableStateOf<Users?>(null) }
    var name by remember { mutableStateOf(user?.name ?: "") }
    var address by remember { mutableStateOf(user?.name ?: "") }
    var about_me by remember { mutableStateOf(user?.name ?: "") }
    var img_user by remember { mutableStateOf(user?.name ?: "") }
    var id_genderFK by remember { mutableStateOf(user?.name ?: "") }
    LaunchedEffect(Unit) { // Запускаем корутину при первом рендере composable
        viewModel.getUserById() // Вызываем функцию из viewModel
        user = viewModel.user.value // Получаем результат из viewModel
        name = user?.name ?: "" // Инициализируем состояние имени
        address = user?.address ?: "" // Инициализируем состояние имени
        about_me = user?.about_me ?: "" // Инициализируем состояние имени
        img_user = user?.img_user ?: "" // Инициализируем состояние имени
        id_genderFK = (user?.id_genderFK ?: "").toString() // Инициализируем состояние имени
    }
    // Создаем CoroutineScope для запуска корутин
    val coroutineScope = rememberCoroutineScope()


    var showDialog by remember { mutableStateOf(false) }
    Image(
        painter = painterResource(id = R.drawable.fon),
        contentDescription = "",
        contentScale = ContentScale.FillHeight,
        modifier = Modifier.fillMaxSize()
    )
    Column(
        modifier = Modifier
            .fillMaxSize()
    ) {
        Spacer(modifier = Modifier.height(20.dp))
        // Верхний блок (2/5 размера экрана)
        Box(
            modifier = Modifier
                .weight(2f)
                .background(Color.LightGray.copy(alpha = 0.8f))
                .padding(16.dp),
            contentAlignment = Alignment.TopCenter
        ) {

            // Кнопки назад и выбора да/нет
            Row(
                modifier = Modifier.fillMaxWidth(),
                horizontalArrangement = Arrangement.SpaceBetween,
                verticalAlignment = Alignment.CenterVertically
            ) {
                IconButton(onClick = { navController.navigate("MenuV") }) {
                    Icon(Icons.Filled.ArrowBack, contentDescription = "Назад")
                }
                IconButton(onClick = { showDialog = true }) {
                    Icon(Icons.Filled.Delete, contentDescription = "Удалить")
                }
            }
            if (showDialog) {
                AlertDialog(
                    onDismissRequest = { showDialog = false },
                    title = { Text("Подтверждение") },
                    text = { Text("Вы точно хотите удалить?") },
                    confirmButton = {
                        Button(
                            onClick = {
                                user?.let {
                                    coroutineScope.launch {
                                        viewModel.deleteUser(it, navController)
                                    }
                                }
                            }
                        ) {
                            Text("Да")
                        }
                    },
                    dismissButton = {
                        Button(onClick = { showDialog = false }) {
                            Text("Нет")
                        }
                    }
                )
            }
            Spacer(modifier = Modifier.height(60.dp))

            // Заголовок "Профиль"
            Text(
                text = "Настройки профиля",
                fontWeight = FontWeight.Bold,
                modifier = Modifier
                    .padding(top = 32.dp)
                    .fillMaxWidth(),
                textAlign = TextAlign.Center
            )

            // Блок с фотографией, именем и гендером
            Column(
                modifier = Modifier
                    .fillMaxWidth()
                    .padding(top = 64.dp),
                horizontalAlignment = Alignment.CenterHorizontally
            ) {
                AsyncImage(
                    model = user?.img_user,
                    contentDescription = null,
                    modifier = Modifier.size(200.dp)
                        .clip(CircleShape)
                        .background(Color.Gray),
                    contentScale = ContentScale.Crop
                )

                // Имя и гендер
                Row(
                    modifier = Modifier
                        .padding(top = 16.dp),
                    verticalAlignment = Alignment.CenterVertically
                ) {
                    Text(
                        text = user?.name ?:""
                    )
                    Spacer(modifier = Modifier.width(8.dp))
                    when (user?.id_genderFK?.toString() ?: "") {
                        "1" -> Text(text = "♂")
                        "2" -> Text(text = "♀") // Или любой другой символ, который вы хотите использовать для значения 2
                        else -> {} // Можно добавить обработку других значений или оставить пустым
                    }
                }
            }
        }

        // Остальной контент (3/5 размера экрана)
        Box(
            modifier = Modifier
                .weight(3f)
                .fillMaxSize()
        ) {
            Column(
                modifier = Modifier
                    .fillMaxWidth()
                    .padding(top = 10.dp),
                horizontalAlignment = Alignment.CenterHorizontally
            ) {
                OutlinedTextField(
                    value = name,
                    onValueChange = { newName ->
                        name = newName // Обновляем состояние имени при изменении текста
                        user?.name = newName // Присваиваем новое имя полю user?.name
                    },
                    label = { Text("Изменить имя", color = Color.Black) },
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(horizontal = 16.dp)
                        .clip(RoundedCornerShape(20.dp)),
                    textStyle = TextStyle(color = Color.Black)
                )
                Spacer(modifier = Modifier.height(10.dp))

                OutlinedTextField(
                    value = address,
                    onValueChange = { newAdress ->
                        address = newAdress // Обновляем состояние имени при изменении текста
                        user?.address = newAdress // Присваиваем новое имя полю user?.name
                    },
                    label = { Text("Изменить адрес", color = Color.Black) },
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(horizontal = 16.dp)
                        .clip(RoundedCornerShape(20.dp)),
                    textStyle = TextStyle(color = Color.Black)
                )

                Spacer(modifier = Modifier.height(10.dp))

                OutlinedTextField(
                    value = about_me,
                    onValueChange = { newAbout_me ->
                        about_me = newAbout_me // Обновляем состояние имени при изменении текста
                        user?.about_me = newAbout_me // Присваиваем новое имя полю user?.name
                    },
                    label = { Text("Изменить информацию о себе", color = Color.Black) },
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(horizontal = 16.dp)
                        .clip(RoundedCornerShape(20.dp)),
                    textStyle = TextStyle(color = Color.Black)
                )
                Spacer(modifier = Modifier.height(10.dp))
                Text(
                    text = viewModel.InfoText.value,
                    fontSize = 18.sp,
                    color = Color.DarkGray
                )
                Spacer(modifier = Modifier.height(20.dp))
                Button(
                    onClick = {
                        user?.let {
                            coroutineScope.launch {
                                viewModel.updateUser(it, navController)
                            }
                        }
                    },
                    modifier = Modifier.width(290.dp).height(50.dp),
                    colors = ButtonDefaults.buttonColors(brown_contrast)
                ) {
                    Text(
                        text = "Сохранить",
                        fontSize = 24.sp,
                        fontFamily = basicNunitosans
                    )
                }
                Spacer(modifier = Modifier.height(10.dp))
                Button(
                    onClick = { navController.navigate("changingPassword") },
                    modifier = Modifier.width(290.dp).height(50.dp),
                    colors = ButtonDefaults.buttonColors(brown_contrast)
                ) {
                    Text(
                        text = "Изменить пароль",
                        fontSize = 24.sp,
                        fontFamily = basicNunitosans
                    )
                }

            }
        }
    }
}